#include <stdio.h>
#include <assert.h>
#include <math.h>

#define MAXV 1000
#define MAXE (MAXV*MAXV)

int x[MAXV], y[MAXV];

struct ee {
   int v1, v2, dsq;
}e[MAXE];

int i,j,k,ne,M,N;

int label[MAXV];
int member[MAXV][MAXV];

void union_find(int j, int k) {
   int i;
	 int lj = label[j];
	 int lk = label[k];
	 if(lj==lk) return;

	 label[j] = lk;
	 for(i=1;i<=N;i++) {
	    if(member[lj][i]) {
			label[i] = lk;
			member[lj][i]=0;
			member[lk][i]=1;
		}
	}
}

int comp(const void *a, const void *b) {
   return (( const struct ee*)a)->dsq - ((const struct ee*)b)->dsq;
	}
main() {
   //freopen("connect.in","r",stdin);
	 double dist;
	 int eused;
	 scanf("%d",&N);
	 assert(1<=N && N <=750);
	 for(i=1;i<=N;i++) {scanf("%d%d",&x[i],&y[i]); assert(abs(x[i])<=10000 && abs(y[i])<=10000); }

	 for(i=1;i<=N;i++) label[i] = i;
	 for(i=1;i<=N;i++) for(j=1;j<=N;j++) member[i][j] = (i==j);

	 scanf("%d",&M);
	 assert(0<=M && M<=1000);
   for(i=0;i<M;i++) {
	    scanf("%d%d",&j,&k);
			union_find(j,k);
	 }

//printf("%d %d ",N,M);
	 ne=0;
	 for(i=1;i<=N;i++) for(j=i+1;j<=N;j++) {
	    e[ne].v1 = i;
			e[ne].v2 = j;
			e[ne++].dsq = (x[i]-x[j])*(x[i]-x[j]) + (y[i]-y[j])*(y[i]-y[j]);
		}
		qsort(e,ne,sizeof(struct ee),comp);

		dist=0.0;
		eused=0;
		for(i=0;i<ne;i++) {
		    if(label[e[i].v1] == label[e[i].v2]) continue;
				union_find(e[i].v1,e[i].v2);
				//printf("%d %d\n",e[i].v1,e[i].v2);
				eused++;
				dist += sqrt( e[i].dsq );
			}
//printf(" %d ",eused);
			printf("%.2f\n",dist);
		}
