#include <stdio.h>
#include <math.h>

double cons[101], time[101], race[101], fuel[101], fuel[101];
int since[101], stops[101], nstops[101];
FILE *ofile;

main(int argc, char **argv){
   int C = 1;
   int laps,i,j,k,l;
   int xlaps;
   double lapt, laptinc, lapc, lapcinc, pt, ptinc;
   double xlapt, xlaptinc, xlapc, xlapcinc, xpt, xptinc;
   int nstops,lastop;
   double xtime,xfuel,xfuel1;
   int xstops,xsince,xsince1;

   if (argc != 3) {
      printf("usage:  blah inputfile outputfile\n");
      exit(1);
   }

   freopen(argv[1],"r",stdin);
   ofile = fopen(argv[2],"r");

   while (7 == scanf("%d %lf %lf %lf %lf %lf %lf\n",
          &laps, &lapt, &laptinc, &lapc, &lapcinc, &pt, &ptinc)){
      printf("=================CASE %d=====================\n",C++);
      fprintf(stdout,"%d %0.3lf %0.3lf %0.3lf %0.3lf %0.3lf %0.3lf\n",
          laps, lapt, laptinc, lapc, lapcinc, pt, ptinc);

      for (i=0; i < laps; i++){
        double x = (cons[i]*lapcinc + lapc)/(1-lapcinc);
        cons[i+1] = cons[i] + x;
        time[i+1] = time[i] + lapt + laptinc*cons[i+1];
      }

      for (i=0;i<=laps;i++){
         race[i] = time[i];
         since[i] = i;
      }

      for (i=1;i<laps;i++){
         for (j=1;j<=laps-i;j++){
            double x = race[i] + time[j] + pt + ptinc*cons[j];
            if (x < race[i+j]) {
               race[i+j] = x;
               since[i+j] = j;
            }
         }
      }

     nstops = 0;
     lastop = laps; 
     for(;;){
       if (lastop == 0) break;
       stops[nstops] = lastop - since[lastop];
       fuel[nstops] = cons[since[lastop]];
       lastop -= since[lastop];
       if (lastop == 0) break;
       nstops++;
     } 

     printf("%0.3lf %0.3lf %d\n",race[laps],fuel[nstops],nstops);
     for (i=nstops-1;i>=0;i--){
        printf("%d %2g\n",stops[i],fuel[i]);
     }
     if (7 != fscanf(ofile,"%d %lf %lf %lf %lf %lf %lf",&xlaps,&xlapt, &xlaptinc, &xlapc, &xlapcinc, &xpt, &xptinc)) {
        printf("missing/bad input\n");
        exit(2);
     }
     if (xlaps!=laps || xlapt!=lapt || xlaptinc !=laptinc || xlapc!=lapc || xlapcinc != lapcinc || xpt != pt || xptinc != ptinc) {
        printf("echoed wrong input values\n");
        exit(2);
     }
     if (3 != fscanf(ofile,"%lf%lf%d",&xtime,&xfuel,&xstops)) {
        printf("missing or wrong time/fuel/stops\n");
        exit(2);
     }
     if (fabs(xtime - race[laps]) > .0025) {
        printf("wrong race time %0.3lf (judge says %0.3lf)\n",xtime,race[laps]);
        exit(2);
     }
     xsince = 0;
     for (i=1;i<=xstops;i++) {
        if (2 != fscanf(ofile,"%d%lf",&xsince1,&xfuel1)) {
           printf("missing/corrupt lap info\n");
           exit(2);
        }
        printf("stop %d at %d laps covered %d\n",i,xsince1,xsince1-xsince);
        printf("fuel needed %0.3lf available %0.3lf\n",cons[xsince1-xsince],
                            xfuel);
        xfuel -= cons[xsince1-xsince];
        if (xfuel < -.0025) {
           printf("ran out of gas\n");
           exit(2);
        }
        xfuel += xfuel1;
        xtime -= time[xsince1-xsince];
        xtime -= pt;
        xtime -= ptinc*(xsince1-xsince);
        printf("time left %0.3lf\n",xtime);
        xsince = xsince1;
     }
     xfuel -= cons[laps-xsince];
     printf("end race fuel remaining %0.3lf\n",xfuel);
     if (xfuel < -.0025) {
        printf("ran out of gas\n");
        exit(2);
     }
     xtime -= time[laps-xsince];
     printf("end race time left %0.3lf\n",xtime);
     if (xtime < -.0025) {
        printf("out of time at end\n");
        exit(2);
     }
     printf("Judge says OK\n");
   }
}
